  - ### 一　分布式系统的经典基础理论
  
    [分布式系统的经典基础理论](https://blog.csdn.net/qq_34337272/article/details/80444032)

     本文主要是简单的介绍了三个常见的概念： **分布式系统设计理念** 、 **CAP定理** 、 **BASE理论** ，关于分布式系统的还有很多很多东西。
   ![分布式系统的经典基础理论总结](https://user-gold-cdn.xitu.io/2018/5/24/1639234237ec9805?w=791&h=466&f=png&s=55908)

  - ### 二　分布式事务
    分布式事务就是指事务的参与者、支持事务的服务器、资源服务器以及事务管理器分别位于不同的分布式系统的不同节点之上。以上是百度百科的解释，简单的说，就是一次大的操作由不同的小操作组成，这些小的操作分布在不同的服务器上，且属于不同的应用，分布式事务需要保证这些小操作要么全部成功，要么全部失败。本质上来说，分布式事务就是为了保证不同数据库的数据一致性。
    * [深入理解分布式事务](http://www.codeceo.com/article/distributed-transaction.html)
    * [分布式事务？No, 最终一致性](https://zhuanlan.zhihu.com/p/25933039)
    * [聊聊分布式事务，再说说解决方案](https://www.cnblogs.com/savorboard/p/distributed-system-transaction-consistency.html)
　　

  - ### 三　分布式系统一致性
    [分布式服务化系统一致性的“最佳实干”](https://www.jianshu.com/p/1156151e20c8)

   - ### 四　一致性协议/算法
     早在1898年就诞生了著名的 **Paxos经典算法** （**Zookeeper就采用了Paxos算法的近亲兄弟Zab算法**），但由于Paxos算法非常难以理解、实现、排错。所以不断有人尝试简化这一算法，直到2013年才有了重大突破：斯坦福的Diego Ongaro、John Ousterhout以易懂性为目标设计了新的一致性算法—— **Raft算法** ，并发布了对应的论文《In Search of an Understandable Consensus Algorithm》，到现在有十多种语言实现的Raft算法框架，较为出名的有以Go语言实现的Etcd，它的功能类似于Zookeeper，但采用了更为主流的Rest接口。
     * [图解 Paxos 一致性协议](http://blog.xiaohansong.com/2016/09/30/Paxos/)
     *  [图解分布式协议-RAFT](http://ifeve.com/raft/)
     *  [Zookeeper ZAB 协议分析](http://blog.xiaohansong.com/2016/08/25/zab/)

- ### 五　分布式存储

  **分布式存储系统将数据分散存储在多台独立的设备上**。传统的网络存储系统采用集中的存储服务器存放所有数据，存储服务器成为系统性能的瓶颈，也是可靠性和安全性的焦点，不能满足大规模存储应用的需要。分布式网络存储系统采用可扩展的系统结构，利用多台存储服务器分担存储负荷，利用位置服务器定位存储信息，它不但提高了系统的可靠性、可用性和存取效率，还易于扩展。 
  
   * [分布式存储系统概要](http://witchiman.top/2017/05/05/distributed-system/)
   
- ### 六　分布式计算

  **所谓分布式计算是一门计算机科学，它研究如何把一个需要非常巨大的计算能力才能解决的问题分成许多小的部分，然后把这些部分分配给许多计算机进行处理，最后把这些计算结果综合起来得到最终的结果。**
  分布式网络存储技术是将数据分散的存储于多台独立的机器设备上。分布式网络存储系统采用可扩展的系统结构，利用多台存储服务器分担存储负荷，利用位置服务器定位存储信息，不但解决了传统集中式存储系统中单存储服务器的瓶颈问题，还提高了系统的可靠性、可用性和扩展性。
  
  * [关于分布式计算的一些概念](https://blog.csdn.net/qq_34337272/article/details/80549020)
  
  